/**
 * @author v_wangyan
 */
function g(id) { 
	return document.getElementById(id);
}	
function randomInt (min, max) {
	return Math.floor(Math.random() * (max - min + 1) + min);
}
function jsonDecode(jsonString) {
	return (new Function("return " + jsonString))();
}
function show(id) {
	isShow(id, true);
}
function hide(id) {
	isShow(id, false);
}
function isShow(id, flag) {
	g(id).style.display = flag? 'block' : 'none';
}
function createElement (className) {
	var div = document.createElement('div');
	div.className = className;
	return div;
}
function addClass(element, className) {
	element = g(element)||element;
    var classArray = className.split(/\s+/),
        result = element.className,
        classMatch = " " + result + " ",
        i = 0,
        l = classArray.length;

    for (; i < l; i++) {
         if ( classMatch.indexOf( " " + classArray[i] + " " ) < 0 ) {
             result += (result ? ' ' : '') + classArray[i];
         }
    }

    element.className = result;
}
function removeClass(element, className) {
	element = g(element)||element;

    var oldClasses = element.className.split(/\s+/),
        newClasses = className.split(/\s+/),
        lenOld,
        lenDel = newClasses.length,
        j,
        i = 0;
    for (; i < lenDel; ++i) {
        for(j = 0, lenOld = oldClasses.length; j < lenOld; ++j) {
            if (oldClasses[j] == newClasses[i]) {
            	oldClasses.splice(j, 1);
            	break;
            }
        }
    }
    element.className = oldClasses.join(' ');
}
function getTimeNow() {
	var t = new Date();
	var hours = t.getHours();
	var minutes = t.getMinutes();
	var seconds = t.getSeconds(); 
	 
	return hours*60*60+minutes*60+seconds*1;
}
//执行命令
function execOrder(order, key) {
	try {
		window.external.SyncRequest(order, key);
	} catch (e) {}
}
//获取信息
function getSyncInfo(order) {
	var info = '';
	try {
		if (window.external.SyncRequest) {
			return window.external.SyncRequest(order);
		} 
	} catch (e) {
		return info;
	}
	return info;
}
/**
 * 设置存储值
 */
function setConfig(key, value) {
    var globalData = getConfigData() || {};
    globalData[key] = value;
    var str = '{';
    var sp = '';

    for (k in globalData) {
        if ('{' != str) {
            sp =',';
        }
        str += sp + '"' + k + '":"' + globalData[k] + '"';
    }

    str += '}';
    try {
    	 window.external.SyncRequest('saveConfig', str);
    } catch (e) {}   
}
/**
 * 获取存储的值
 */
function getConfig(key) { 
    var globalData = getConfigData();
    if (globalData && typeof globalData[key] != 'undefined') { 
        return globalData[key];
    }

    return null;
}
function getConfigData() {
	try {
		if (window.external.SyncRequest) {
			var strJSON = window.external.SyncRequest('readConfig'); 
			strJSON= jsonDecode(strJSON);
			return strJSON;
		}  
	} catch (e) {
		 return null;
	}	
   
}
//获取参数
function execSync(order, param) {
	try {
		if (window.external.SyncRequest) {
			return window.external.SyncRequest(order,param);
		} 
	} catch (e) {
		return '';
	}
	return '';
}
//给RD调用
function setButtonState(key, statu) {
	var status = skins.buttonstatus;
	var id = '';
	key = key || '0';
	try {
		id = status[key].id;
		statu =  statu || (g(id).getAttribute('statu') == '0' ? '1' : '0');	
		g(id).style.background = 'url(images/icons/' + status[key][statu] + ')'; 
		g(id).setAttribute ('statu', statu); 
	} catch(e) {}
			
}
/**
 * 设置输入法状态  
 * 参数:0 (中英文切换)	返回值: 0 英文 1 中文;
 * 参数:1 (全半角切换)	返回值: 0 半角 1 全角; 
 * 参数:2 (中英文标点)	返回值: 0 英文标点 1 中文标点;
 * 参数:3 (软键盘)
 * 参数:4 (登录)			返回值: 0 未登录 1 已登录
 * 参数:5 (配置)
 */
function setIMEStatus() {
	setButtonState('0', getExecStatus('language', '0'));		
	setButtonState('2', getExecStatus('punctuation', '2'));	
	setButtonState('4', getExecStatus('login', '4'));	
}
//获取RD数据status,null 时返回当前状态
function getExecStatus(id, key) { 
	try {
		var statu = execSync('getButtonState', key) || g(id).getAttribute('statu'); 
		return statu;
	} catch (e) {
		return '0';
	}	
}	
//处理点击-取消冒泡事件
function execMouseDown (e, rightClick, key) {
	e.stopPropagation(); 
	
	var order = rightClick ? 'mouseRDown' : 'mouseLDown';
	execOrder(order, key);
}
//右键点击
function rightButton(id) {
	if (event.button == 2) {
		execMouseDown(event, true, id);
	}
}
//设置页面显示的字体
function setFontFamily(key) {	//设置字体:  0-宋体 ; 1-微软雅黑;
	key = key || '0';
	var obj = document.body;
	var font = '';
	if (key) {
		font = '"微软雅黑", "宋体", Arial, Verdana';
	} else {
		font = '"宋体", "微软雅黑", Arial, Verdana';
	}
	obj.style.fontFamily = font;
}
//是否为win7--雅黑字
function getSysver() {
	var key = 0;
	try {
		key = window.external.SyncRequest('sysver');
		if ('6.1' == key) {
			key = 1;
		}
	} catch (e) {	}	
	
	setFontFamily(key);	
}
//ime 滑动效果
function slide(dom, count, num, order) {
	window.setTimeout(function () {
		if ( num == count) {	
			return;					
		}
		dom[num].className = 'icon ' + dom[num].id + ' slide-' + order;
		num ++;
		
		slide(dom, count, num, order);
	}, 80);
	
}
//滑动效果-查看下一道
function nextQuestion(obj) { 
	var left = parseInt(obj.style.left); 
	left --;
	obj.style.left = left + 'px';
	if (left % 110 != 0) {
		window.setTimeout(function() {					
			nextQuestion(obj);
		}, 4);
	}else{
		obj.removeChild(obj.getElementsByTagName('div')[0]);
		obj.style.left = '0px';
	}			
}
//返回冒泡事件的ID
function bubbleId(e) {
	var tar =e.srcElement || e.target;
	var id =tar.id.toLowerCase();
	return id || '';
}
//剩余天数
function setLastBackground(num) { 
	g('dayCount').style.backgroundImage = 'url(images/icons/' + num + '.png)';
}
//设置显示内容
function setSkinMode(showDom, matchClsss) {
	g('main').className = 'main ' + matchClsss;
	
	var domItem = ['dayCount', 'lastDay', 'answer', 'medal', 'lottery', 'submitAnswer'];
	var len = domItem.length;
	var showLen = showDom.length;
	for (var i =0; i < len; i++ ) {
		hide(domItem[i]);			
	}	
	for (var j = 0; j < showLen; j++) {
		show(showDom[j]);
	}	
}
//设置标题滚动(参数:题目id号)
function setScrollTitle(id){
	clearTimeout(timer);
	titleBox = g("titleBox" + id);
	title1 = g("title1-" + id);
	title2 = g("title2-" + id);
	title3 = g("title3-" + id);
	scrollObj = g("scroll" + id); 
	scrollObj.style.width = (title1.offsetWidth * 3 + 100) + "px"; 
	title2.innerHTML = title1.innerHTML;
	title3.innerHTML = title1.innerHTML;
	timer = setTimeout(scrollTitle, 30)
		
}
function scrollTitle() {
	if (title1.offsetWidth <= titleBox.scrollLeft) {
		titleBox.scrollLeft -= title1.offsetWidth*2;
	} else {
		titleBox.scrollLeft ++;
	}
	
	timer = setTimeout(scrollTitle, 30);
}
//获取竞猜选项
function getRadioValue(id) {
    var radios = g('answerList').getElementsByTagName('input');
    var result = false;
    for (var i = 0 , iLen = radios.length; i < iLen ; i ++) {
        if (radios[i].type == 'radio' && radios[i].checked) {
            result = radios[i].value;
            break;
        }
    }

    return result;
}

//生成竞猜题
function processQuestion(questionData) {
	var timmerID = + new Date();
	var len = questionData.options.length;
	var index = '';
	var html = [];
	html[html.length] = '<div class="answer-item">';
	html[html.length] = '	<div class="title-box" onmouseover="hoverQuestionTitle(this, true)" onmouseout="hoverQuestionTitle(this, false)"><div class="title-text">' + questionData.title + '</div></div>';
	html[html.length] = '	<div class="options text-color">';

	var str = '';
	for (var i=0; i < len; i++) {
		var option = questionData.options[i];
		index =  questionData.id + '-' + option.sort;
		str += '<label for="item_' + timmerID + '_' + index + '"><input type="radio" onclick="bindRadioClick()" name="item' + questionData.id + '" id="item_' + timmerID + '_' + index + '" value="' + option.val + '" />' + setTextRule(option.text, 14) + '</label> <br />';
	}
	html[html.length] = str;
	html[html.length] = '	</div>'; 
	html[html.length] = '</div>'; 
	g('answerList').innerHTML = g('answerList').innerHTML + html.join(''); 
}
// 处理奖牌榜
function processMedal(medalData) {
	var medalItem = null;
	var medalHtml = '';
	var medalBox = g('medalBox'); 
	medalBox.innerHTML = '';
	var len = medalData.length;
	for (var i=0; i < len; i++) { 
	  	medalItem = createElement('medal-item');
	  	medalHtml = '<h5><span class="num">' + medalData[i].rank + '.</span>' + medalData[i].team + '</h5>\
					<div class="info">\
						<div class="gold">' + medalData[i].jin + '</div>\
						<div class="silver">' + medalData[i].yin + '</div>\
						<div class="bronze">' + medalData[i].tong + '</div>\
					</div>';
		medalItem.innerHTML = medalHtml;
		medalBox.appendChild(medalItem);
	};
}
//获取奖牌榜
var getMedalTimmer = 30;
var getMedialInterval = null;
function getMedal(needInterval) {
	baidu.ajax.request(medalUrl + '?t=' + (+new Date()),{
		timeout: 3000,
		onsuccess:function (xhr, result) {
			result = result || {};
			if(typeof result == 'string'){
				result = JSON.parse(result);
			}
			if (result.error_msg && result.error_msg.length != 0) {
				if(result.error_msg == 'over') {
					if(getMedialInterval){
						window.clearInterval(getMedialInterval);
						getMedialInterval = null;
					}
				}
				setSkinMode(['lastDay', 'lottery'], 'match');
				return;
			}
			
			var st = parseInt(result.interval || 30);
			if(getMedalTimmer != st){
				getMedalTimmer = st;
				tryMedalInterval(needInterval);
			}
			processMedal(result.data);
			
			setSkinMode(['medal', 'lottery'], 'match');
		},
		onfailure: function () {
			setSkinMode(['lastDay', 'lottery'], 'match');
		},
		ontimeout: function (xhr) {
			setSkinMode(['lastDay', 'lottery'], 'match');
		}
	});

	tryMedalInterval(needInterval);
}

function tryMedalInterval(needInterval){
	if(needInterval && getMedialInterval){
		window.clearInterval(getMedialInterval);
		getMedialInterval = null;
	}
	if(needInterval){
		getMedialInterval = window.setInterval(function(){
			getMedal();
		}, getMedalTimmer * 60 * 1000);
	}
}
//设置提交按钮状态 (true: 可用; false: 不可用)
function setSubmitDisabled(able) {
	if (able) {				
		g('submit').disabled = false;
		g('submit').className = '';
	} else {
		g('submit').disabled = true;
		g('submit').className = 'btn-disable';
	}
}
//单选框选中时触发： 检查是否登陆(0 非点击按钮； 1 点击按钮)
function bindRadioClick(eventType) { 
	if ('' == getSyncInfo('GetUserLoginInfo')) {
		login('2');
		isSubmit = 2;
	}  else {
		setSubmitDisabled(true);
	} 
}
/*
 * 登陆：
 * 0：只登陆不操作   
 * 1: 登陆成功后，RD需调用提交接口
 * 2：登陆成功后，RD需调用-提交按钮为可用状态 接口
 */
function login(loginType) {
	execOrder('UserLogin', loginType);
}
//更新登陆状态
function updateUserLoginInfo(val) {
	if (val && val.length>0) {
		if (isSubmit == '1') {
			sunmitAnswers();
		} else if (isSubmit =='2') {	//更改按钮状态
			setSubmitDisabled(true);
		}
	}
}
//提交
function sunmitAnswers() {
	var answer = getRadioValue(questionId);
	if (answer === false) {
		return;
	}
	var uid = getSyncInfo('GetUserLoginInfo');
	 if ('' == uid) {
		 login('1');
		 isSubmit = '1';
		 return;
	 }
	
	var radioVal = getRadioValue();
	postCount ++;	
	//var data = {user_id:uid, id:questionId, answer:radioVal};
	var postStr = "user_id=" + uid + "&id=" + questionId + "&answer=" + radioVal;
	
	baidu.ajax.request(answerUrl + '?t=' + (+new Date()),{
		method: 'post',
		data: postStr,
		timeout: 3000,
		onsuccess:function (xhr, result) {
			result = result || {};
			if(typeof result == 'string'){
				result = JSON.parse(result);
			}
			if (result.error_msg && result.error_msg.length != 0) {
				return;
			}

			if (result.data.result == 'success') { 
				getQuestion();
			}
		},
		onfailure: function (xhr) { //处理提交失败			
			if (postCount == 2) {  
				getQuestion();	
				return;
			};
			sunmitAnswers();
		},
		ontimeout: function (xhr) { 
			 if (postCount == 2) {  
				 getQuestion();	
				 return;
			 };
			 sunmitAnswers();
		}
	});
	
}
//设置显示模式
function getSkinMode(month, days) { 
	if (month == 6) { 
		days = 30 - days + 28;
	} else if (month == 7) {
		days  = 28 - days;
	} else {
		days = -1;
	}
	if (days > 1 && days <= 30) { //倒计时
		setLastBackground(days); 	
		setSkinMode(['dayCount'], '');
	} else if (days == 1 || days > 30) {	//倒计时最后一天
		setSkinMode(['lastDay', 'lottery'], 'match');
	} else {	//获取竞猜题目	
		g('answerList').style.left = '0px';
		getQuestion();				
	}
}
//重设dom显示		
function setCountDown() {  
	try {
		baidu.ajax.request(timeUrl + '?t=' + (+new Date()), {
			timeout: 3000,
			onsuccess:function (xhr, result) {
				result = result || {};
				if(typeof result == 'string'){
					result = JSON.parse(result);
				}
				if (result.error_msg && result.error_msg.length != 0) {
					resetGetServerTime(120000);
					getSkinMode(new Date().getMonth() + 1, new Date().getDate());
					return;
				}
				
				if (result.data) {
					var d = result.data.serverTime;
					var date = d.split(' ')[0];
					var time = d.split(' ')[1];
					var year = date.split('/')[0], month = date.split('/')[1], day = date.split('/')[2];
					var hour = time.split(":")[0], min = time.split(":")[1], sec = time.split(":")[2];
					
					//var newD = new Date(year, month - 1, day, hour, min, sec);
					getSkinMode(month * 1, day * 1);					
				} 
				resetGetServerTime(3600000);

			},
			onfailure: function (xhr) {
				//getSkinMode(7, parseInt(4));
				//setSkinMode(['lastDay', 'lottery'], 'match');
				getSkinMode(new Date().getMonth() + 1, new Date().getDate());
				resetGetServerTime(120000);
			},
			ontimeout: function (xhr) {
				//setSkinMode(['lastDay', 'lottery'], 'match');
				getSkinMode(new Date().getMonth() + 1, new Date().getDate());
				resetGetServerTime(120000);
			}
		}, {encode: 'utf-8'});	
	} catch (e) {
		//g('test').innerHTML = '异常';
	}			
}
// 字符长度
function getLen(str){
	var len=0,
		abc='';
	for(i=0;i<str.length;i++)
	{
		abc=str.charAt(i);
		if(str.charCodeAt(i)>255)
			len=len+2;
		else
			len=len+1;
	}
	return len;
}
/**
 * 长度限制
 * str:目标字符串
 * rule:规则(maxlength)
 */
function setTextRule(str,rule){
	var len=0,
		abc='',
		newStr="",
		k=0; 
	if(rule==getLen(str) || rule>getLen(str)){ 
		return str;
	}else{  
		rule=rule-4;
		for(i=0;i<str.length;i++)
		{
			abc=str.charAt(i);
			if(str.charCodeAt(i)>255)
				len=len+2;
			else
				len=len+1;
			if(!(len>rule)){
				k=i;
				newStr=newStr+abc;
			}				
		}			
		return newStr+"..";
	}		
}



function hoverQuestionTitle(obj, isHover){
	var t = obj.getElementsByTagName('div')[0];
	if(!(obj.clientWidth < t.clientWidth)){
		return;
	}

	if(isHover){
		t.className = 'title-text hover';
	}else{
		t.className = 'title-text';
	}
}





//打印log
function Log(str) {
	try {
		if(window.external.SyncRequest)
		{
			window.external.SyncRequest('log', str);
		}
		else
		{
			console.log(str);
		}
	} catch (e) {}
}
